*** linux-2.0.28/net/bridge/br.c	Thu Nov  7 22:44:27 1996
--- KERNEL/net/bridge/br.c	Mon Nov 24 22:51:05 1997
***************
*** 39,47 ****
  #include <asm/segment.h>
  #include <asm/system.h>
  #include <net/br.h>
  
  static int br_device_event(struct notifier_block *dnot, unsigned long event, void *ptr);
- static void br_tick(unsigned long arg);
  int br_forward(struct sk_buff *skb, int port);	/* 3.7 */
  int br_port_cost(struct device *dev);	/* 4.10.2 */
  void br_bpdu(struct sk_buff *skb); /* consumes skb */
--- 39,72 ----
  #include <asm/segment.h>
  #include <asm/system.h>
  #include <net/br.h>
+ #include <net/ip.h>
+ 
+ /*
+  * WebShield bridging removes most of the BPDU standards overhead and
+  * uses the key algorithms and structures.  Turn off the removed
+  * portions with '#ifdef WS_BRIDGE_NOTDEF'.
+  */
+ #ifdef WS_BRIDGE_NOTDEF
+ #undefine WS_BRIDGE_NOTDEF
+ #endif
+ 
+ /*
+  * Turn off the diagnostic counters and remove the WSbridgelog file
+  * unless CONFIG_WEBSHIELD_DEBUG is turned on in the config file.
+  */
+ #ifdef CONFIG_WEBSHIELD_DEBUG
+ /* Diagnostic counters for /proc/net/WSbridgelog. */
+ int br_found_cnt = 0, br_notfound_cnt = 0, br_learned_cnt = 0;
+ int br_dropped_cnt = 0, br_devdropped_cnt = 0;
+ int br_tx_cnt = 0, br_queuexmit_cnt = 0, br_forwarded_cnt = 0, br_receive_cnt=0;
+ int br_scancheck_cnt = 0, br_host_cnt = 0, br_scanproto_cnt = 0;
+ int br_scantcp_cnt = 0, br_noscan_cnt = 0;
+ #define DEBUG_INCR(x)	x++
+ #else
+ #define DEBUG_INCR(x)
+ #endif /* CONFIG_WEBSHIELD_DEBUG */
  
  static int br_device_event(struct notifier_block *dnot, unsigned long event, void *ptr);
  int br_forward(struct sk_buff *skb, int port);	/* 3.7 */
  int br_port_cost(struct device *dev);	/* 4.10.2 */
  void br_bpdu(struct sk_buff *skb); /* consumes skb */
***************
*** 66,73 ****
  
  struct br_stat br_stats;
  
- static struct timer_list tl; /* for 1 second timer... */
- 
  /*
   * the following structure is required so that we receive
   * event notifications when network devices are enabled and
--- 91,96 ----
***************
*** 79,84 ****
--- 102,108 ----
  	0
  };
  
+ #ifdef WS_BRIDGE_NOTDEF
  /** Elements of Procedure (4.6) **/
  
  /*
***************
*** 441,452 ****
--- 465,478 ----
  		stop_forward_delay_timer(port_no);/* (4.6.13.3.3) */
  	}
  }
+ #endif /* WS_BRIDGE_NOTDEF */
  
  void set_port_state(int port_no, int state)
  {
  	port_info[port_no].state = state;
  }
  
+ #ifdef WS_BRIDGE_NOTDEF
  void received_config_bpdu(int port_no, Config_bpdu *config)		  /* (4.7.1)	 */
  {
  	int         root;
***************
*** 574,584 ****
--- 600,612 ----
  		transmit_config(port_no);	  /* (4.7.8.1)	 */
  	}					  /* (4.6.1.2.3)	 */
  }
+ #endif /* WS_BRIDGE_NOTDEF */
  
  void br_init(void)
  {						  /* (4.8.1)	 */
  	int             port_no;
  
+ #ifdef WS_BRIDGE_NOTDEF
  	printk(KERN_INFO "Ethernet Bridge 002 for NET3.035 (Linux 2.0)\n");
  	bridge_info.designated_root = bridge_info.bridge_id;	/* (4.8.1.1)	 */
  	bridge_info.root_path_cost = Zero;
***************
*** 597,606 ****
  	bridge_info.top_change = 0;
  	stop_tcn_timer();
  	stop_topology_change_timer();
  	for (port_no = One; port_no <= No_of_ports; port_no++) {	/* (4.8.1.4) */
  		br_init_port(port_no);
- 		disable_port(port_no);
  	}
  	port_state_selection();			  /* (4.8.1.5)	 */
  	config_bpdu_generation();		  /* (4.8.1.6)	 */
  	
--- 625,635 ----
  	bridge_info.top_change = 0;
  	stop_tcn_timer();
  	stop_topology_change_timer();
+ #endif /* WS_BRIDGE_NOTDEF */
  	for (port_no = One; port_no <= No_of_ports; port_no++) {	/* (4.8.1.4) */
  		br_init_port(port_no);
  	}
+ #ifdef WS_BRIDGE_NOTDEF
  	port_state_selection();			  /* (4.8.1.5)	 */
  	config_bpdu_generation();		  /* (4.8.1.6)	 */
  	
***************
*** 608,613 ****
--- 637,643 ----
  	tl.expires = jiffies+HZ;	/* 1 second */
  	tl.function = br_tick;
  	add_timer(&tl);
+ #endif /* WS_BRIDGE_NOTDEF */
  
  	register_netdevice_notifier(&br_dev_notifier);
  	br_stats.flags = 0; /*BR_UP | BR_DEBUG*/;	/* enable bridge */
***************
*** 616,621 ****
--- 646,653 ----
  
  void br_init_port(int port_no)
  {
+ 	set_port_state(port_no, Blocking);
+ #ifdef WS_BRIDGE_NOTDEF
  	become_designated_port(port_no);	  /* (4.8.1.4.1) */
  	set_port_state(port_no, Blocking);	  /* (4.8.1.4.2)    */
  	port_info[port_no].top_change_ack = 0;
***************
*** 623,640 ****
  	stop_message_age_timer(port_no);	  /* (4.8.1.4.5)	 */
  	stop_forward_delay_timer(port_no);	  /* (4.8.1.4.6)	 */
  	stop_hold_timer(port_no);		  /* (4.8.1.4.7)	 */
  }
  
  void enable_port(int port_no)				  /* (4.8.2)	 */
  {
! 	br_init_port(port_no);
! 	port_state_selection();			  /* (4.8.2.7)	 */
  }						  /* */
  
  void disable_port(int port_no)				  /* (4.8.3)	 */
  {
! 	int         root;
! 
  	root = root_bridge();
  	become_designated_port(port_no);	  /* (4.8.3.1)	 */
  	set_port_state(port_no, Disabled);	  /* (4.8.3.2)	 */
--- 655,673 ----
  	stop_message_age_timer(port_no);	  /* (4.8.1.4.5)	 */
  	stop_forward_delay_timer(port_no);	  /* (4.8.1.4.6)	 */
  	stop_hold_timer(port_no);		  /* (4.8.1.4.7)	 */
+ #endif /* WS_BRIDGE_NOTDEF */
  }
  
  void enable_port(int port_no)				  /* (4.8.2)	 */
  {
! 	set_port_state(port_no, Forwarding);
  }						  /* */
  
  void disable_port(int port_no)				  /* (4.8.3)	 */
  {
! 	set_port_state(port_no, Disabled);	  /* (4.8.3.2)	 */
! 	port_info[port_no].dev->internal = 0;
! #ifdef WS_BRIDGE_NOTDEF
  	root = root_bridge();
  	become_designated_port(port_no);	  /* (4.8.3.1)	 */
  	set_port_state(port_no, Disabled);	  /* (4.8.3.2)	 */
***************
*** 653,661 ****
--- 686,696 ----
  		config_bpdu_generation();	  /* (4.8.3.8.4)    */
  		start_hello_timer();
  	}
+ #endif /* WS_BRIDGE_NOTDEF */
  }
  
  
+ #ifdef WS_BRIDGE_NOTDEF
  void set_bridge_priority(bridge_id_t *new_bridge_id)		  /* (4.8.4)	 */
  {
  
***************
*** 983,988 ****
--- 1018,1024 ----
  	restore_flags(flags);
  	return(0);
  }
+ #endif /* WS_BRIDGE_NOTDEF */
  
  static int br_device_event(struct notifier_block *unused, unsigned long event, void *ptr)
  {
***************
*** 1017,1023 ****
  			if ((port_info[i].dev == (struct device *)0) ||
  				(port_info[i].dev == dev)) {
  				port_info[i].dev = dev;
! 				enable_port(i);
  				set_path_cost(i, br_port_cost(dev));
  				set_port_priority(i, 128); 
  				port_info[i].port_id = i;
--- 1053,1061 ----
  			if ((port_info[i].dev == (struct device *)0) ||
  				(port_info[i].dev == dev)) {
  				port_info[i].dev = dev;
! /* Let br_ioctl() do this part. */
! /*				enable_port(i); */
! #ifdef WS_BRIDGE_NOTDEF
  				set_path_cost(i, br_port_cost(dev));
  				set_port_priority(i, 128); 
  				port_info[i].port_id = i;
***************
*** 1029,1034 ****
--- 1067,1073 ----
  					set_bridge_priority(&bridge_info.bridge_id);
  				}	
  				make_forwarding(i);
+ #endif /* WS_BRIDGE_NOTDEF */
  				return NOTIFY_DONE;
  				break;
  			}
***************
*** 1044,1049 ****
--- 1083,1195 ----
  }
  
  /*
+  * Peek at the network and transport protocols to see if this packet
+  * is scanable.
+  */
+ int brscancheck(struct sk_buff *skb, int port)
+ {
+ 	struct fdb *f;
+ 	struct ethhdr *eth = skb->h.eth;
+ 
+ 	DEBUG_INCR(br_scancheck_cnt);
+ 	/* check for a broadcast */
+ 	if (eth->h_dest[0] & 0x01) 
+ 	{
+ 		/* group address */
+ 		br_flood(skb, port);
+ 		return(0);
+ 	}
+ 
+ 	/* check for packet directed at this interface */
+ 	if (memcmp(eth->h_dest, port_info[port].dev->dev_addr, ETH_ALEN) == 0)
+ 	{
+ 		/* Packet is for us */
+ 		DEBUG_INCR(br_host_cnt);
+ 		skb->pkt_type = PACKET_HOST;
+ 		return(0);	/* pass frame up our stack (this will */
+ 				/* happen in net_bh() in dev.c) */
+ 	}
+ 
+ 	/* check for packet directed at the internal interface */
+ 	/* (only if this external interface has an IP address) */
+ 	if (!port_info[port].dev->internal && port_info[port].dev->pa_addr) {
+ 		int aport;
+ 		for (aport = One; aport <= No_of_ports; aport++)
+ 		{
+ 			if (port_info[aport].state == Forwarding &&
+ 				port_info[aport].dev->internal)
+ 			{
+ 				if (memcmp(eth->h_dest,
+ 					port_info[aport].dev->dev_addr,
+ 					ETH_ALEN) == 0)
+ 				{
+ 					skb->pkt_type = PACKET_HOST;
+ 					DEBUG_INCR(br_host_cnt);
+ 					return(0);
+ 				}
+ 			}
+ 		}
+ 	}
+ 	/* locate port to forward to */
+ 	f = br_avl_find_addr(skb->h.eth->h_dest);
+ 	if (f && f->flags & FDB_ENT_VALID)
+ 	{
+ 		if (f->timer + fdb_aging_time > CURRENT_TIME) {
+ 			/*
+ 			 * The fdb entry still valid, so check its port.
+ 			 * If that port's state is not Forwarding, then
+ 			 * we drop the packet because the destination
+ 			 * LAN is not being scanned.
+ 			 * If that port matches the incoming port, then
+ 			 * we drop the packet because the destination is
+ 			 * on the same LAN as the source.
+ 			 */
+ 			if (port_info[f->port].state != Forwarding)
+ 				return(br_drop(skb));
+ 			if (f->port==port)	/* same port as arrival */
+ 				return(br_drop(skb));	/* no need to scan */
+ 			/* we have a valid and non-source port fdb entry */
+ 		} else {
+ 			/* timer expired, invalidate entry */
+ 			f->flags &= ~FDB_ENT_VALID;
+ 			if (br_stats.flags & BR_DEBUG)
+ 				printk("fdb entry expired...\n");
+ 		}
+ 	}
+ 
+ 	DEBUG_INCR(br_scanproto_cnt);
+ 	/*
+ 	 * This interface is being bridged.
+ 	 *
+ 	 * We still have not decided to bridge it or queue it.
+ 	 * This requires knowledge of Network & Transport protocols.
+ 	 * Now the drivers set skb->protocol with eth_type_trans(),
+ 	 * and net_bh() sets skb->ip_hdr before sending us the packet.
+ 	 */
+ 	switch(ntohs(skb->protocol)) {
+ 	case ETH_P_IP: {
+ 		struct iphdr *iph = skb->ip_hdr;
+ 
+ 		switch(iph->protocol) {
+ 		case IPPROTO_TCP:	/* catch TCP packets */
+ 			skb->ipcatch = 1;
+ 			DEBUG_INCR(br_scantcp_cnt);
+ 			return(0);	/* pass it up the stack */
+ 			break;
+ 		case IPPROTO_UDP:	/* bridge UDP (for now) */
+ 		default:		/* bridge other IP protocols */
+ 			break;
+ 		}
+ 		break;
+ 	}
+ 	default:	/* bridge all other ether types */
+ 		break;
+ 	}
+ 	DEBUG_INCR(br_noscan_cnt);
+ 	return(br_forward(skb, port));
+ }
+ 
+ /*
   * following routine is called when a frame is received
   * from an interface, it returns 1 when it consumes the
   * frame, 0 when it does not
***************
*** 1052,1058 ****
  int br_receive_frame(struct sk_buff *skb)	/* 3.5 */
  {
  	int port;
- 	int i;
  	
  	if (br_stats.flags & BR_DEBUG)
  		printk("br_receive_frame: ");
--- 1198,1203 ----
***************
*** 1095,1102 ****
--- 1240,1249 ----
  		return(0);
  	}
  
+ 	DEBUG_INCR(br_receive_cnt);
  	switch (port_info[port].state) 
  	{
+ #ifdef WS_BRIDGE_NOTDEF
  		case Learning:
  			(void) br_learn(skb, port);	/* 3.8 */
  			/* fall through */
***************
*** 1109,1114 ****
--- 1256,1262 ----
  			/* fall through */
  		case Blocking:
  			/* fall through */
+ #endif /* WS_BRIDGE_NOTDEF */
  		case Disabled:
  			/* should drop frames, but for now, we let
  			 * them get passed up to the next higher layer
***************
*** 1118,1123 ****
--- 1266,1272 ----
  			break;
  		case Forwarding:
  			(void) br_learn(skb, port);	/* 3.8 */
+ #ifdef WS_BRIDGE_NOTDEF
  			/* process BPDUs */
  			if (memcmp(skb->h.eth->h_dest, bridge_ula, 
  					ETH_ALEN) == 0) 
***************
*** 1138,1143 ****
--- 1287,1294 ----
  			}
  			/* ok, forward this frame... */
  			return(br_forward(skb, port));
+ #endif /* WS_BRIDGE_NOTDEF */
+ 			return(brscancheck(skb, port));
  		default:
  			printk(KERN_DEBUG "br_receive_frame: port [%i] unknown state [%i]\n",
  				port, port_info[port].state);
***************
*** 1172,1179 ****
  	if (skb->dev->flags & IFF_LOOPBACK)
  		return(0);
  
  	skb->h.raw = skb->data;
! 	port = 0;	/* an impossible port */	
  	if (br_stats.flags & BR_DEBUG)
  		printk("br_tx_fr : port %i src %02x:%02x:%02x:%02x:%02x:%02x\
  	  		dest %02x:%02x:%02x:%02x:%02x:%02x\n", 
--- 1323,1361 ----
  	if (skb->dev->flags & IFF_LOOPBACK)
  		return(0);
  
+ 	/*
+ 	 * As in bridge_xmit(), check for a panic condition reported
+ 	 * at a customer site.  Dump the skb and free the packet.
+ 	 */
+ 	if (skb->data < skb->head || skb->data > skb->end) {
+ 		unsigned int *wp;
+ 		int i;
+ 		printk("br_tx_frame: bad head/data/end %p/%p/%p\n",
+ 			skb->head, skb->data, skb->end);
+ 		printk("  skb=%p, h.raw=%p, mac.raw=%p, tail=%p, len=%d\n",
+ 			skb, skb->h.raw, skb->mac.raw, skb->tail,(int)skb->len);
+ 		/*
+ 		 * alloc_skb() disassembly shows 0x98 bytes or 38 words
+ 		 * in an skbuff struct.  Dump it.
+ 		 * This dumps 6 lines of 6 words and one line of 2 words.
+ 		 */
+ 		for (i=0, wp=(unsigned int *)skb; i<36; i+=6, wp+=6) {
+ 			printk("  %08x %08x %08x %08x %08x %08x\n",
+ 				wp[0], wp[1], wp[2], wp[3], wp[4], wp[5]);
+ 		}
+ 		printk("  %08x %08x\n", wp[0], wp[1]);
+ 		printk("Dropping it\n");
+ 		/* kfree_skb(skb, 0); Don't... this may panic. */
+ 		return(1);
+ 	}
+ 	DEBUG_INCR(br_tx_cnt);
  	skb->h.raw = skb->data;
! 	if (skb->indev)
! 		/* Must not xmit on incoming port */
! 		/* or else sender will see its own packet. */
! 		port = find_port(skb->indev);
! 	else
! 		port = 0;	/* an impossible port */	
  	if (br_stats.flags & BR_DEBUG)
  		printk("br_tx_fr : port %i src %02x:%02x:%02x:%02x:%02x:%02x\
  	  		dest %02x:%02x:%02x:%02x:%02x:%02x\n", 
***************
*** 1203,1208 ****
--- 1385,1391 ----
  {
  	struct fdb *f;
  
+ #ifdef WS_BRIDGE_NOTDEF
  	switch (port_info[port].state) {
  		case Listening:
  		case Blocking:
***************
*** 1212,1221 ****
--- 1395,1415 ----
  			/* break; */
  		case Learning:
  		case Forwarding:
+ #endif /* WS_BRIDGE_NOTDEF */
  			/* don't keep group addresses in the tree */
  			if (skb->h.eth->h_source[0] & 0x01)
  				return(-1);
  			
+ 			f = br_avl_find_addr(skb->h.eth->h_source);
+ 			if (f) { /* common case */
+ 				f->timer = CURRENT_TIME;
+ 				f->flags = FDB_ENT_VALID;
+ 				f->port = port;
+ 				DEBUG_INCR(br_found_cnt);
+ 				return (0);
+ 			}
+ 			DEBUG_INCR(br_notfound_cnt);
+ 
  			f = (struct fdb *)kmalloc(sizeof(struct fdb), 
  				GFP_ATOMIC);
  
***************
*** 1239,1247 ****
--- 1433,1444 ----
  			/* add to head of port chain */
  			f->fdb_next = port_info[port].fdb;
  			port_info[port].fdb = f;
+ 			DEBUG_INCR(br_learned_cnt);
  			return(0);
  			/* break */
+ #ifdef WS_BRIDGE_NOTDEF
  	}
+ #endif /* WS_BRIDGE_NOTDEF */
  }
  
  /*
***************
*** 1250,1255 ****
--- 1447,1453 ----
  
  int br_drop(struct sk_buff *skb)
  {
+ 	DEBUG_INCR(br_dropped_cnt);
  	kfree_skb(skb, 0);
  	return(1);
  }
***************
*** 1260,1265 ****
--- 1458,1464 ----
  
  int br_dev_drop(struct sk_buff *skb)
  {
+ 	DEBUG_INCR(br_devdropped_cnt);
  	dev_kfree_skb(skb, 0);
  	return(1);
  }
***************
*** 1273,1278 ****
--- 1472,1478 ----
  {
  	struct fdb *f;
  	
+ 	DEBUG_INCR(br_forwarded_cnt);
  	/*
     	 * flood all ports with frames destined for a group
  	 * address.  If frame came from above, drop it,
***************
*** 1306,1312 ****
  		/*
  		 *	Sending
  		 */
! 		if (f->port!=port && port_info[f->port].state == Forwarding) {
  			/* has entry expired? */
  			if (f->timer + fdb_aging_time < CURRENT_TIME) {
  				/* timer expired, invalidate entry */
--- 1506,1512 ----
  		/*
  		 *	Sending
  		 */
! 		if (f->port!=port) {
  			/* has entry expired? */
  			if (f->timer + fdb_aging_time < CURRENT_TIME) {
  				/* timer expired, invalidate entry */
***************
*** 1330,1335 ****
--- 1530,1536 ----
  			 */
  			 
  			skb->dev=port_info[f->port].dev;
+ 			DEBUG_INCR(br_queuexmit_cnt);
  			 
  			/*
  			 *	We send this still locked
***************
*** 1360,1366 ****
  	{
  		if (i == port)
  			continue;
! 		if (port_info[i].state == Forwarding) 
  		{
  			nskb = skb_clone(skb, GFP_ATOMIC);
  			if(nskb==NULL)
--- 1561,1567 ----
  	{
  		if (i == port)
  			continue;
! 		if (port_info[i].dev)
  		{
  			nskb = skb_clone(skb, GFP_ATOMIC);
  			if(nskb==NULL)
***************
*** 1386,1397 ****
  	int i;
  
  	for (i = One; i <= No_of_ports; i++)
! 		if ((port_info[i].dev == dev) && 
! 			(port_info[i].state != Disabled))
  			return(i);
  	return(0);
  }
  
  int br_port_cost(struct device *dev)	/* 4.10.2 */
  {
  	if (strncmp(dev->name, "eth", 3) == 0)	/* ethernet */
--- 1587,1598 ----
  	int i;
  
  	for (i = One; i <= No_of_ports; i++)
! 		if (port_info[i].dev == dev)
  			return(i);
  	return(0);
  }
  
+ #ifdef WS_BRIDGE_NOTDEF
  int br_port_cost(struct device *dev)	/* 4.10.2 */
  {
  	if (strncmp(dev->name, "eth", 3) == 0)	/* ethernet */
***************
*** 1523,1529 ****
--- 1724,1793 ----
  	/*NOTREACHED*/
  	return 0;
  }
+ #endif /* WS_BRIDGE_NOTDEF */
  
+ /* This is largely copied from dev_ifsioc(). */
+ int br_ioctl(unsigned int cmd, void *arg)
+ {
+ 	struct ifreq ifr;
+ 	struct device *dev, *ext;
+ 	int inport, outport;
+ 
+ 	/* Fetch the caller's info block into kernel space. */
+ 	int err=verify_area(VERIFY_WRITE, arg, sizeof(struct ifreq));
+ 	if(err)
+ 		return err;
+ 	memcpy_fromfs(&ifr, arg, sizeof(struct ifreq));
+ 
+ 	/* See which interface the caller is talking about. */
+ 	if ((dev = dev_get(ifr.ifr_name)) == NULL) 	
+ 		return(-ENODEV);
+ 	if ((inport=find_port(dev)) == 0)
+ 		return(-ENODEV);
+ 
+ 	switch(cmd) {
+ 	case SIOCGIFBR:
+ 		/* This ioctl is currently unused, skip it. */
+ 		return(0);
+ 		break;
+ 
+ 	case SIOCSIFBR:
+ 		ext = dev_get(ifr.ifr_slave);
+ 
+ 		if(ext) { /* enable bridging */
+ 			if (br_stats.flags & BR_UP)
+ 				return(-EADDRINUSE);
+ 			if ((outport=find_port(ext)) == 0)
+ 				return(-ENODEV);
+ 			br_stats.flags |= BR_UP;	/* enable bridge */
+ 			enable_port(inport);
+ 			enable_port(outport);
+ 			port_info[inport].dev->internal = 1;
+ 			return(0);
+ 		} else { /* disable bridging */
+ 			if (!(br_stats.flags & BR_UP))
+ 				return(-ENODEV);	/* already disabled */
+ 			for (inport = One; inport <= No_of_ports; inport++)
+ 				if (port_info[inport].state == Forwarding) {
+ 					disable_port(inport);
+ 				}
+ 			br_stats.flags &= ~BR_UP;	/* disable bridge */
+ 			return(0);
+ 		}
+ 		break;
+ 	case SIOCBRNODEBUG:
+ 		br_stats.flags &= ~BR_DEBUG;
+ 		break;
+ 	case SIOCBRDEBUG:
+ 		br_stats.flags |= BR_DEBUG;
+ 		break;
+ 	default:
+ 		return(-EINVAL);
+ 	}
+ 	return(0);
+ }
+ 
+ #ifdef WS_BRIDGE_NOTDEF
  int br_cmp(unsigned int *a, unsigned int *b)
  {
  	int i;	
***************
*** 1538,1541 ****
  	}
  	return(0);
  }
! 		
--- 1802,1940 ----
  	}
  	return(0);
  }
! #endif /* WS_BRIDGE_NOTDEF */
! 
! /*
!  * Provide a hook for ARP to change an external device's source hardware
!  * address to the internal device's hardware address.
!  */
! char *a2b_src_hw(struct device *dev, char *src_hw)
! {
! 	int port_no, internal_port=0;
! 	int found_port=0;
! 	struct device *dev2;
! 
! 	for (port_no = One; port_no <= No_of_ports; port_no++) {
! 		dev2 = port_info[port_no].dev;
! 		if (!dev2)
! 			continue;
! 		if (dev2 == dev) {
! 			if (port_info[port_no].state != Forwarding)
! 				return (src_hw);
! 			if (dev2->internal)
! 				return (src_hw);
! 			found_port++;
! 		}
! 		if (dev2->internal)
! 			internal_port = port_no;
! 	}
! 	/*
! 	 * If the specified device is bridged and we found an internal
! 	 * interface, use the internal interface's hardware address.
! 	 */
! 	if (found_port && internal_port)
! 		return (port_info[internal_port].dev->dev_addr);
! 	return (src_hw);
! }
! 
! #ifdef CONFIG_WEBSHIELD_DEBUG
! /*
!  * Provide the contents of /proc/net/WSbridgelog.
!  */
! extern void proc_usedata(char *buffer, char *tmpbuf,
! 	int *pos, int offset, int *len);
! 
! int WSbridgelog_get_info(char *buffer, char **start, off_t offset, int length, int dummy)
! {
! 	int len = 0; /* offset from the start of the given buffer */
! 	int pos = 0; /* offset from the start of the file */
! 	int i, port;
! 	char tmpbuf[200]; /* Good enough? */
! 	unsigned char *p;
! 	struct fdb *f;
! 
! 	*start = buffer;
! 
!     for (port = 0, i=0; port < 3; port++) {
! 	f = port_info[port].fdb;
! 	for (; i < 1000 && f != NULL; f = f->fdb_next) {
! 		p = f->ula;
! 		sprintf(tmpbuf, "fdb %d: %02x:%02x:%02x:%02x:%02x:%02x (%d)",
! 			i, p[0], p[1], p[2], p[3], p[4], p[5], f->port);
! 		/* get 3 MAC addresses per line: 23*3+6=75 chars */
! 		if (f->fdb_next != NULL) {
! 			f = f->fdb_next;
! 			i++;
! 			p = f->ula;
! 			sprintf(tmpbuf + strlen(tmpbuf),
! 				", %02x:%02x:%02x:%02x:%02x:%02x (%d)",
! 				p[0], p[1], p[2], p[3], p[4], p[5], f->port);
! 		}
! 		if (f->fdb_next != NULL) {
! 			f = f->fdb_next;
! 			i++;
! 			p = f->ula;
! 			sprintf(tmpbuf + strlen(tmpbuf),
! 				", %02x:%02x:%02x:%02x:%02x:%02x (%d)",
! 				p[0], p[1], p[2], p[3], p[4], p[5], f->port);
! 		}
! 		sprintf(tmpbuf + strlen(tmpbuf), "\n");
! 		proc_usedata(buffer, tmpbuf, &pos, offset, &len);
! 		if (len >= length)
! 			return length;
! 	}
!     }
! 	sprintf(tmpbuf, "Found %d forwarding database records\n\n", i);
! 	proc_usedata(buffer, tmpbuf, &pos, offset, &len);
! 	if (len >= length)
! 		return length;
! 
! 	sprintf(tmpbuf, "Learning: found/notfound/learned = %d/%d/%d\n",
! 		br_found_cnt, br_notfound_cnt, br_learned_cnt);
! 	proc_usedata(buffer, tmpbuf, &pos, offset, &len);
! 	sprintf(tmpbuf, "Dropped: dropped/devdropped = %d/%d\n",
! 		br_dropped_cnt, br_devdropped_cnt);
! 	proc_usedata(buffer, tmpbuf, &pos, offset, &len);
! 	if (len >= length)
! 		return length;
! 
! 	sprintf(tmpbuf, "Out: tx (from system to bridge): %d\n", br_tx_cnt);
! 	proc_usedata(buffer, tmpbuf, &pos, offset, &len);
! 	sprintf(tmpbuf, "Out: queuexmit (from bridge to device): %d\n",
! 		br_queuexmit_cnt);
! 	proc_usedata(buffer, tmpbuf, &pos, offset, &len);
! 	sprintf(tmpbuf, "Out: forward (from system or bridge to bridge): %d\n",
! 		br_forwarded_cnt);
! 	proc_usedata(buffer, tmpbuf, &pos, offset, &len);
! 	if (len >= length)
! 		return length;
! 
! 	sprintf(tmpbuf, "In: receive_frame (from device to bridge): %d\n",
! 		br_receive_cnt);
! 	proc_usedata(buffer, tmpbuf, &pos, offset, &len);
! 	if (len >= length)
! 		return length;
! 
! 	sprintf(tmpbuf, "Scan: checked for scanning: %d\n", br_scancheck_cnt);
! 	proc_usedata(buffer, tmpbuf, &pos, offset, &len);
! 	sprintf(tmpbuf, "Scan: target at me: %d\n", br_host_cnt);
! 	proc_usedata(buffer, tmpbuf, &pos, offset, &len);
! 	sprintf(tmpbuf, "Scan: checked protocol in header: %d\n",
! 		br_scanproto_cnt);
! 	proc_usedata(buffer, tmpbuf, &pos, offset, &len);
! 	sprintf(tmpbuf, "Scan: found TCP in header: %d\n", br_scantcp_cnt);
! 	proc_usedata(buffer, tmpbuf, &pos, offset, &len);
! 	sprintf(tmpbuf, "Scan: not scanned: %d\n", br_noscan_cnt);
! 	proc_usedata(buffer, tmpbuf, &pos, offset, &len);
! 	if (len >= length)
! 		return length;
! 
! 	sprintf(tmpbuf, "\nBridge is %s.\n",
! 		(br_stats.flags & BR_UP) ? "up" : "down");
! 	proc_usedata(buffer, tmpbuf, &pos, offset, &len);
! 
! 	if (len > length)
! 		len = length;
! 	return len;
! }
! #endif /* CONFIG_WEBSHIELD_DEBUG */
*** linux-2.0.28/net/bridge/br_tree.c	Mon May 13 02:15:24 1996
--- KERNEL/net/bridge/br_tree.c	Thu Jul 31 12:02:54 1997
***************
*** 217,222 ****
--- 217,223 ----
  		if (addr_cmp(new_node->ula, node->ula) == 0) { /* update */
  			node->flags = new_node->flags;
  			node->timer = new_node->timer;	
+ 			node->port = new_node->port;	
  			return(0);
  		}
  		if (addr_cmp(new_node->ula, node->ula) < 0) {
*** linux-2.0.28/net/core/dev.c	Wed Nov  6 04:39:47 1996
--- KERNEL/net/core/dev.c	Thu Jul 31 12:02:52 1997
***************
*** 256,261 ****
--- 256,262 ----
  	if (ret == 0) 
  	{
  		dev->flags |= (IFF_UP | IFF_RUNNING);
+ 		dev->internal = 0;
  		/*
  		 *	Initialise multicasting status 
  		 */
***************
*** 308,313 ****
--- 309,318 ----
  				kfree_skb(skb,FREE_WRITE);
  		ct++;
  	}
+ 	/*
+ 	 *	Also disconnect from scanned device pair.
+ 	 *	This turns bridging off in both devices.
+ 	 */
  	return(0);
  }
  
***************
*** 328,333 ****
--- 333,378 ----
  }
  
  /*
+  *	Bridging code has decided to transmit.  Set the packet up
+  *	correctly, first.  Caller must:
+  *	1. make sure sock accounting for this packet is FREE_WRITE,
+  *		because that is what the consuming driver will use.
+  *		In kfree_skb(), skbuffs associated with socks are
+  *		accounted for in the socks' read and write memory
+  *		allocation counters (rmem_alloc and wmem_alloc).
+  *		Failure to do this will cause a sock leak because
+  *		destroy_sock will not free the sock until these
+  *		counts are 0.
+  *	2. The caller should no longer muck with skb->len.  This is
+  *		because enough mechanisms muck with skb->len along
+  *		with the now-variable skb->data that bridge_xmit()
+  *		will fix them both.  This routine can only be called
+  *		for packets which have had skb->mac initialized as
+  *		is done by individual drivers calling eth_type_trans().
+  */
+ void bridge_xmit(struct sk_buff *skb, struct device *dev, int pri)
+ {
+ 	skb->arp = 1;
+ /*
+  * One customer (at least) reports a panic apparently caused by mac.raw
+  * getting set to time in seconds.  This is an early report of data and
+  * len when a bad mac.raw is detected.  A more thorough dump is made in
+  * br_tx_frame().
+  */
+ 	if (skb->mac.raw < skb->head || skb->mac.raw > skb->end)
+ 		printk("bridge_xmit: bad head/mac.raw/end %p/%p/%p\n",
+ 			skb->head, skb->mac.raw, skb->end);
+ 	if (skb->data < skb->head || skb->data > skb->end)
+ 		printk("bridge_xmit: bad head/data/end %p/%p/%p\n",
+ 			skb->head, skb->data, skb->end);
+ 
+ 	skb->len += (skb->data - skb->mac.raw);
+ 	skb->data = skb->mac.raw;
+ 	skb->pkt_bridged = 0;
+ 	dev_queue_xmit(skb, dev, pri);
+ }
+ 
+ /*
   *	Send (or queue for sending) a packet. 
   *
   *	IMPORTANT: When this is called to resend frames. The caller MUST
***************
*** 608,614 ****
  		 *	If we are bridging then pass the frame up to the
  		 *	bridging code. If it is bridged then move on
  		 */
! 		 
  		if (br_stats.flags & BR_UP)
  		{
  			/*
--- 653,661 ----
  		 *	If we are bridging then pass the frame up to the
  		 *	bridging code. If it is bridged then move on
  		 */
! 		/* bridge-layer scanning initialization */
! 		skb->ipcatch = 0;
! 		skb->indev = skb->dev;
  		if (br_stats.flags & BR_UP)
  		{
  			/*
***************
*** 617,622 ****
--- 664,671 ----
  			 */
  			 
  			int offset=skb->data-skb->mac.raw;
+ 			/* for possible use by brscancheck() */
+ 			skb->ip_hdr = (struct iphdr *) skb->data;
  			cli();
  			skb_push(skb,offset);	/* Put header back on for bridge */
  			if(br_receive_frame(skb))
***************
*** 703,710 ****
  		 * 	Has an unknown packet has been received ?
  		 */
  	 
! 		else
! 			kfree_skb(skb, FREE_WRITE);
  		/*
  		 *	Again, see if we can transmit anything now. 
  		 *	[Ought to take this out judging by tests it slows
--- 752,766 ----
  		 * 	Has an unknown packet has been received ?
  		 */
  	 
! 		else {
! 			/* bridge packets of unknown type */
! 			/* netif_rx() should prevent this */
! 			if(skb->ipcatch) {
! 				bridge_xmit(skb, skb->dev, 0);
! 			} else
! 				kfree_skb(skb, FREE_WRITE);
! 		}
! 
  		/*
  		 *	Again, see if we can transmit anything now. 
  		 *	[Ought to take this out judging by tests it slows
*** linux-2.0.28/net/core/skbuff.c	Wed Jun  5 23:45:39 1996
--- KERNEL/net/core/skbuff.c	Thu Jul 31 12:02:52 1997
***************
*** 67,72 ****
--- 67,74 ----
  
  extern atomic_t ip_frag_mem;
  
+ extern int count_timer(void);
+ 
  void show_net_buffers(void)
  {
  	printk(KERN_INFO "Networking buffers in use          : %u\n",net_skbcount);
***************
*** 77,82 ****
--- 79,85 ----
  #ifdef CONFIG_INET
  	printk(KERN_INFO "IP fragment buffer size            : %u\n",ip_frag_mem);
  #endif	
+ 	printk(KERN_INFO "The timer_head list has %d timers\n", count_timer());
  }
  
  #if CONFIG_SKB_CHECK
***************
*** 640,647 ****
  	{
  		static int count = 0;
  		if (++count < 5) {
! 			printk(KERN_ERR "alloc_skb called nonatomically from interrupt %p\n",
! 				__builtin_return_address(0));
  			priority = GFP_ATOMIC;
  		}
  	}
--- 643,652 ----
  	{
  		static int count = 0;
  		if (++count < 5) {
! 			printk(KERN_ERR "alloc_skb called nonatomically from interrupt %p, %p, %p\n",
! 				__builtin_return_address(0),
! 				__builtin_return_address(1),
! 				__builtin_return_address(2));
  			priority = GFP_ATOMIC;
  		}
  	}
***************
*** 702,707 ****
--- 707,713 ----
  	skb->end=bptr+len;
  	skb->len=0;
  	skb->destructor=NULL;
+ 	skb->indev=NULL;
  	return skb;
  }
  
*** linux-2.0.28/net/core/sock.c	Tue Oct 29 17:42:42 1996
--- KERNEL/net/core/sock.c	Mon Nov 24 22:51:30 1997
***************
*** 342,347 ****
--- 342,352 ----
  
  void sk_free(struct sock *sk)
  {
+ #if CONFIG_WEBSHIELD_DEBUG
+ 	extern void free_sockevents();
+ 	free_sockevents(sk);
+ #endif /* CONFIG_WEBSHIELD_DEBUG */
+ 
  	kfree_s(sk,sizeof(*sk));
  }
  
